/**
 * Represents an ice cream with chocolate flavor
 */
public class ChocolateIceCream extends IceCream {

  public ChocolateIceCream(boolean waffleCone, boolean lactoseFree) {
    this.flavor = "CHOCOLATE";
    this.waffleCone = waffleCone;
    this.lactoseFree = lactoseFree;
  }

  @Override
  public String getFlavor() {
    return this.flavor;
  }

  @Override
  public boolean hasWaffleCone() {
    return this.waffleCone;
  }

  @Override
  public boolean isLactoseFree() {
    return this.lactoseFree;
  }
}
