/**
 * An ice cream factory produces the correct type of ice cream when given a
 * flavor. Users also have the opportunity to specify if they want a waffle
 * cone and a lactose free ice cream
 */
public class IceCreamFactory {
  // THIS IS AN EXAMPLE OF THE FACTORY DESIGN PATTERN

  // This class is not an ADT

  /**
   * Returns an ice cream with the specified flavor
   * @param flavor the icecream flavor
   * @return IceCream with the flavor, no waffle cone, not lactose free
   * null if flavor doesn't exist
   */
  public static IceCream makeIceCreamWithFlavor(String flavor) {
    // Use makeIceCream to create a plain ice cream.
    // TODO
    return null;
  }

  /**
   * Returns an ice cream with the specified flavor served on a waffle cone
   *
   * @param flavor the flavor of the ice cream
   * @return IceCream with the flavor on a waffle cone, not lactose free.
   * null if flavor doesn't exist
   */
  public static IceCream makeIceCreamWithWaffleCone(String flavor) {
    // Use makeIceCream to create a waffle cone.
    // TODO
    return null;
  }

  /**
   * Returns an ice cream with the specified flavor and also lactose free
   *
   * @param flavor the flavor of the ice cream
   * @return IceCream with the flavor, lactose free, in a cup. null if flavor
   * doesn't exist
   */
  public static IceCream makeLactoseFreeIceCream(String flavor) {
    // Use makeIceCream to create a lactose free ice cream.
    // TODO
    return null;
  }

  /**
   * Returns an ice cream with the specified flavor, lactose free, served on
   * waffle cone
   *
   * @param flavor the flavor of the ice cream
   * @return IceCream with the flavor, lactose free, on a waffle cone. null if
   * flavor doesn't exist
   */
  public static IceCream makeLactoseFreeIceCreamOnWaffle(String flavor) {
    // Use makeIceCream to create a lactose free waffle cone.
    // TODO
    return null;
  }

  /**
   * Returns an ice cream that corresponds with the flavor, waffle cone, and
   * lactose mode
   *
   * @param flavor the flavor of the ice cream
   * @param waffleCone whether it should be on a waffle cone
   * @param lactoseFree whether it should be lactose free
   * @return IceCream matching the criterias. null if flavor doesn't exist
   */
  private static IceCream makeIceCream(String flavor, boolean waffleCone,
                                 boolean lactoseFree) {
    flavor = flavor.toUpperCase();

    switch (flavor) {
      case "CHOCOLATE":
        // Create a chocolate ice cream.
        // TODO
        return null;
      case "VANILLA":
        // Create a vanilla ice cream.
        // TODO
        return null;
      case "NEAPOLITAN":
        // Create a neapolitan ice cream.
        // TODO
        return null;
      default:
        // Handle the non existent case.
        return null;
    }
  }
}
