/**
 * Represents an ice cream with neapolitan flavor
 */
public class NeapolitanIceCream extends IceCream {

  public NeapolitanIceCream(boolean waffleCone, boolean lactoseFree) {
    this.flavor = "NEAPOLITAN";
    this.waffleCone = waffleCone;
    this.lactoseFree =lactoseFree;
  }

  @Override
  public String getFlavor() {
    return this.flavor;
  }

  @Override
  public boolean hasWaffleCone() {
    return this.waffleCone;
  }

  @Override
  public boolean isLactoseFree() {
    return this.lactoseFree;
  }
}
